## 5 HTML-purkaja

**Tehtävä:**

Luvun viimeinen tehtävä on hieman poikkeuksellinen, koska tällä kertaa ei luoda itse pääohjelmaa, vaan ainaostaan kirjastomoduuli, joka toteuttaa ohjelman haluaman toiminnon. Itse ohjelmassa poistetaan HTML-muotoilumerkintöjä tekstin seasta ja tulostetaan siistitty teksti ruudulle.

Tehtävää varten on luotu ohjelmakoodi, joka kutsuu metodia nimeltä siisti; argumentiksi metodi saa yhden täyden HTML-kuvauksen yhtenä pitkänä merkkijonona. lähdekooditiedosto on seuraavanlainen:

```
require "7-5"
tiedosto = File.open("7-5_tiedosto.txt")
rivit = ""

tiedosto.each{|rivi| rivit << rivi}
tiedosto.close

tulos = siisti(rivit)
puts tulos
```

HTML-kuvaus tarkoittaa verkkosivujen muotoilukuvausta, jossa esimerkiksi tekstipalstat ja otsikoksi tarkoitetut tekstit on merkitty -merkkien väliin tulevilla HTML-kuvauskielen komennoilla.

Ohjelmalla on siis tarkoitus poistaa hakasulkeiden sisällä olevat muotoiluohjeet luettavasta tulosteesta. Käytännössä tämä tarkoittaa sitä, että tehtävänäsi on määritellä uusi moduuli, jossa on metodi siisti, joka läpikäy argumenttina saamansa merkkijonon ja poistaa html-kuvausmerkit ja niiden sisällön korvaamalla ne välilyönneillä.

Jos kirjoitettu moduuli toimii oikein, tulostaa ohjelma seuraavaa:

Example output:

```
                         

               "Rails-singulariteetti" on tavallinen termi Ruby-
työkalujen ja ympäristöjen keskuudessa. Se tarkoittaa kehitysympäristölle 
yhteensopivuustasoa, jolla ympäristö pystyy toteuttamaan Ruby on Rails-kehyksen 
toiminnot. Näitä kehitysympäristöjä ei ole montaa.     
              
   Rubyn suunnittelun lähtökohtana on ollut käytettävyys ja tehokkuus. Kielen
alkuperäinen suunnittelija, Yukihiro Matsumoto, onkin korostanut tätä ajatusta 
toteamalla, että perinteinen ohjelmointitapa pyrkii selittämään asioita 
tietokoneen ymmärtämällä tavalla huolimatta siitä, että loppujenlopuksi 
tietokoneen tulisi ainoastaan olla laite, jonka avulla ihmiset voivat hyödyntää 
toistensa tekemää työtä.     
```

**Vastaus**

```
#!/usr/bin/env ruby
# coding: utf-8

require "./7-5_purkaja.rb"
tiedosto = File.open("7-5_tiedosto.txt")
rivit = ""

tiedosto.each{|rivi| rivit << rivi}
tiedosto.close

tulos = siisti(rivit)
puts tulos
```

Tiedosto 7-5_purkaja.rb:

```
# coding: utf-8

def siisti(rivit)
    s = []

    for rivi in rivit.split("\n")

        # Kuinka monta merkkiä korvataan?
        merkkiMaara = rivi.split("").length - rivi.gsub(/<[^>]*>/, "").split("").length

        korv = ""
        i = 0
        while i < valit
            merkkiMaara += " "
            i += 1
        end
        s.insert(-1, rivi.gsub(/<[^>]*>/, korv))
    end
    return s
end
```
