## 2 Argumentit ja paluuarvot

**Tehtävä:**

Toinen metodeja käsittelevä ohjelma on myös yksinkertainen syötteitä muokkaava ohjelma.

Määrittele ohjelmaan metodi muuntaja, joka saa syötteenä yhden argumentin nimeltä syote. Lisää metodiin toiminnot, jotka muuttavat kaikki syote-merkkijonon a-kirjaimet y:ksi, l-kirjaimet g:ksi ja lopuksi kaikki kirjaimet isoiksi kirjaimiksi.

Lisätään ohjelmaan myös käyttöliittymä; ohjelma alkaa pyytämällä käyttäjältä tekstiä muodossa "Kirjoita jotain:". Kun syöte on käsitelty, tulostetaan tulos muodossa "Käsittelyn jälkeen tulos on: [muutettu syöte]"

Toimiessaan oikein ohjelma tulostaa seuraavaa:

Example output:

```
Kirjoita jotain: 
ohjelmointia
Käsittelyn jälkeen tulos on: OHJEGMOINTIY
```

**Vastaus**

```
#!/usr/bin/env ruby
# coding: utf-8

def muuntaja(lause, muutaSuureksi=true, *kirjainmuutokset)

    for muutos in kirjainmuutokset
        if muutos.length > 2
            puts "Varoitus: liian pitkä lista: #{muutos}"
        end
        lause = lause.gsub(muutos[0], muutos[1])
    end

    if muutaSuureksi
        lause = lause.upcase
    end

    return lause

end

puts "Kirjoita jotain: "
syote = String(gets.chomp)

printf("Käsittelyn jälkeen tulos on: %s\n", muuntaja(syote, true, ["a", "y"], ["l", "g"] ))
```
