# Ruby basics

Ruby fundamentals through coding exercises.

Contents of this repository are based on [Ruby programming course material](https://campusonline.fi/course/ruby-ohjelmointi) provided by Metropolia University of Applied Sciences.

**NOTE**: Assignments and their descriptions are in Finnish for meanwhile. I have a plan to translate them to English.

## Contents

- [Fundamentals](1_fundamentals)

    - Description: Ruby syntax and basic methods

- [Data types](2_datatypes)

    - Description: Different datatypes in Ruby

- [Logical operators and conditions](3_logical-operators-and-conditions)

    - Description: `if/else` statements & `case` structure in Ruby

- [Loops](4_loops)

    - Description: `for`, `while` and `until` loops in Ruby

- [External files](5_external-files)

    - Description: File operations in Ruby

- [Methods](6_methods)

    - Description: Custom methods in Ruby

- [Modules](7_modules)

    - Description: Custom modules in Ruby

- [Errors and exceptions](8_errors)

    - Description: Error and exception handling in Ruby

- [Classes and objects](9_classes-and-objects)

    - Description: Custom classes and objects in Ruby
